## kadu 1.0

=== CMakeLists.txt ===
project (Kadu)

cmake_minimum_required (VERSION 2.8.10)

# Options (some of them)

option (ENABLE_DEVELOPER_BUILD "Turn on some features helpful during development process (has nothing to do with debugging symbols)" OFF)
option (INSTALL_SDK "Install SDK (API headers, CMake modules, MSVC program libraries)" ON)
option (BUILD_TESTING "Build the test suite." "${ENABLE_DEVELOPER_BUILD}")

# Global CMake variables

list (INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

set (CMAKE_INCLUDE_CURRENT_DIR ON)
set (CMAKE_AUTOMOC ON)

if (NOT DEFINED CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
	if (ENABLE_DEVELOPER_BUILD)
		set (default Debug)
	else ()
		set (default RelWithDebInfo)
	endif ()

	set (CMAKE_BUILD_TYPE "${default}" CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif ()

# C++11 support, warnings and other flags

set (DEFINITIONS QT_USE_QSTRINGBUILDER QT_NO_CAST_TO_ASCII)
if (BUILD_TESTING)
	list (APPEND DEFINITIONS KADU_EXPORT_TESTS)
endif ()
set (DEFINITIONS_DEBUG DEBUG_ENABLED DEBUG_OUTPUT_ENABLED)

if (MSVC)
	set (COMMON_COMPILE_FLAGS "/MP /Zc:wchar_t-")
	list (APPEND DEFINITIONS _CRT_SECURE_NO_WARNINGS=1)
else ()
	set (COMMON_COMPILE_FLAGS "-Wall -Wextra -Wundef -Wunused -Wuninitialized -Wcast-align -Wpointer-arith -fno-common")
	set (C_FLAGS "-Wwrite-strings")
	set (CXX_FLAGS "-Woverloaded-virtual -Wnon-virtual-dtor -std=c++0x")
	set (CMAKE_CXX_FLAGS "-std=c++0x")

	if (NOT WIN32)
		set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -fvisibility=hidden")
		set (CXX_FLAGS "${CXX_FLAGS} -fvisibility-inlines-hidden")
	endif ()

	# Qt 4.8.5 cannot detect Clang's C++11 features, it depends on
	# detected GCC version, anc Clang mimics GCC 4.2.1. Let's mimic
	# GCC 4.8.1.
	if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
		set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -U__GNUC_MINOR__ -D__GNUC_MINOR__=8")
	endif ()

	if (ENABLE_DEVELOPER_BUILD)
		# -pipe can speed up the build
		# -ftrapv generates trap on signed integer overflow, which is undefined by C/C++
		# -fno-omit-frame-pointer gives potentially better stack traces at the cost of negligible performance drop
		set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -Werror -Wno-deprecated -pipe -ftrapv -fno-omit-frame-pointer")

		if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
			set (SANITIZE_OPTIONS "-fsanitize=integer -fsanitize=undefined-trap -fsanitize=unsigned-integer-overflow")
			set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} ${SANITIZE_OPTIONS} -fsanitize-blacklist=${CMAKE_SOURCE_DIR}/sanitize-blacklist.txt")
			set (LINK_FLAGS "${LINK_FLAGS} ${SANITIZE_OPTIONS}")
			# Clang is links its sanitizer libraries only to executables,
			# even though they are actually needed all over the code. :-(
			set (ALLOW_UNDEFINED ON)
		endif ()

		if (CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "GNU")
			# -z now checks there are no unresolved symbols at executalbe/library load time, instead of that specific symbol load time
			set (LINK_FLAGS "${LINK_FLAGS} -Wl,-z,now -Wl,--as-needed")
		endif ()
	endif ()

	if (NOT ALLOW_UNDEFINED AND (CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "GNU"))
		set (LINK_FLAGS "${LINK_FLAGS} -Wl,--no-undefined")
	endif ()
endif ()

# Look above, DEBUG_ENABLED is always enabled in Debug configuration.
# Enable it in all configurations when ENABLE_DEVELOPER_BUILD is on.
if (ENABLE_DEVELOPER_BUILD)
	list (APPEND DEFINITIONS DEBUG_ENABLED)
endif ()

# The same notes as DEBUG_ENABLED concern also DEBUG_OUTPUT_ENABLED.
# Additionally, Windows needs DEBUG_OUTPUT_ENABLED because we always
# install kadu_c.exe with console output.
if (ENABLE_DEVELOPER_BUILD OR WIN32)
	list (APPEND DEFINITIONS DEBUG_OUTPUT_ENABLED)
endif ()

# Version information

file (STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" KADU_VERSION LIMIT_COUNT 1)

find_package (Git QUIET)
if (GIT_FOUND)
	execute_process (COMMAND "${GIT_EXECUTABLE}" describe --tags --exact-match HEAD
		WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
		RESULT_VARIABLE result
		OUTPUT_VARIABLE git_tag
		ERROR_QUIET
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)

	if (NOT (result STREQUAL 0) OR NOT (git_tag STREQUAL KADU_VERSION))
		execute_process (COMMAND "${GIT_EXECUTABLE}" rev-parse --short --verify HEAD
			WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
			RESULT_VARIABLE result
			OUTPUT_VARIABLE git_commit
			ERROR_QUIET
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)

		if (result STREQUAL 0)
			set (KADU_VERSION "${KADU_VERSION}-g${git_commit}")
		endif ()
	endif ()
endif ()

string (REGEX REPLACE "-.*" "" simple_version ${KADU_VERSION})

if (NOT KADU_VERSION STREQUAL simple_version)
	set (KADU_PRERELEASE TRUE)
endif ()

# Installation paths.

set (INSTALL_SDK_DIR "" CACHE PATH "SDK installation root")
mark_as_advanced (INSTALL_SDK_DIR)
if (NOT INSTALL_SDK_DIR)
	set (INSTALL_SDK_DIR "${CMAKE_INSTALL_PREFIX}/sdk")
	set (install_sdk_dir_set_to_default TRUE)
endif ()

include (GNUInstallDirs)

set (INSTALL_BIN_DIR "${CMAKE_INSTALL_FULL_BINDIR}")
set (INSTALL_LIB_DIR "${CMAKE_INSTALL_FULL_LIBDIR}")
set (INSTALL_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/kadu")
set (INSTALL_PLUGINS_DATA_DIR "${INSTALL_DATA_DIR}/plugins")
set (INSTALL_PLUGINS_LIB_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/kadu/plugins")
set (INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/kadu")
set (INSTALL_CMAKE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/cmake/Kadu")

if (install_sdk_dir_set_to_default)
	set (INSTALL_SDK_DIR "${INSTALL_DATA_DIR}/sdk")
endif ()

if (WIN32)
	set (KADU_DATADIR_RELATIVE_TO_BIN "./")
	set (KADU_PLUGINS_LIBDIR_RELATIVE_TO_BIN "./plugins/")
else ()
	file (RELATIVE_PATH KADU_DATADIR_RELATIVE_TO_BIN "${INSTALL_BIN_DIR}" "${INSTALL_DATA_DIR}")
	file (RELATIVE_PATH KADU_PLUGINS_LIBDIR_RELATIVE_TO_BIN "${INSTALL_BIN_DIR}" "${INSTALL_PLUGINS_LIB_DIR}")
endif ()

if (UNIX AND NOT APPLE)
	set (DESKTOP_FILE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/applications")
	set (DESKTOP_FILE_NAME kadu.desktop)

	file (RELATIVE_PATH KADU_DESKTOP_FILE_DIR_RELATIVE_TO_BIN "${INSTALL_BIN_DIR}" "${DESKTOP_FILE_DIR}")
endif ()

set (install_vars
	INSTALL_SDK_DIR INSTALL_BIN_DIR INSTALL_LIB_DIR INSTALL_DATA_DIR INSTALL_PLUGINS_DATA_DIR
	INSTALL_PLUGINS_LIB_DIR INSTALL_INCLUDE_DIR INSTALL_CMAKE_DIR
)
foreach (install_var ${install_vars})
	if (NOT DEFINED ${install_var})
		message (FATAL_ERROR "Variable ${install_var} does not exist")
	else ()
		if (IS_ABSOLUTE "${${install_var}}")
			file (TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}" sane_install_prefix)
			file (TO_CMAKE_PATH "${${install_var}}" sane_install_path)
			if (sane_install_path STREQUAL sane_install_prefix)
				set (RELATIVE_${install_var} "")
			else ()
				string (REPLACE "${sane_install_prefix}/" "" RELATIVE_${install_var} "${sane_install_path}")
			endif ()
			if (RELATIVE_${install_var} STREQUAL "")
				set (RELATIVE_${install_var} ".")
			endif ()

			if (IS_ABSOLUTE "${RELATIVE_${install_var}}")
				message (FATAL_ERROR "${install_var} (${${install_var}}) is not under install prefix.")
			endif ()
		else ()
			set (RELATIVE_${install_var} "${${install_var}}")
		endif()
	endif ()
endforeach ()

set (INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
set (path_vars INSTALL_PREFIX)
if (UNIX AND NOT APPLE)
	list (APPEND path_vars DESKTOP_FILE_DIR)
endif ()

# Generate CMake configuration files

include (CMakePackageConfigHelpers)

macro (kadu_configure_package_config_file _in _out _mode)
	if ("${_mode}" STREQUAL BUILD_TREE)
		foreach (path_var ${path_vars})
			set (PACKAGE_${path_var} "${${path_var}}")
		endforeach ()

		set (PACKAGE_INCLUDE_DIR "${CMAKE_SOURCE_DIR}")
		set (PACKAGE_SDK_DIR "${CMAKE_SOURCE_DIR}")

		configure_package_config_file ("${_in}" "${_out}"
			INSTALL_DESTINATION "${INSTALL_CMAKE_DIR}"
			NO_SET_AND_CHECK_MACRO NO_CHECK_REQUIRED_COMPONENTS_MACRO
		)
	elseif ("${_mode}" STREQUAL INSTALL_TREE)
		set (INCLUDE_DIR "${INSTALL_INCLUDE_DIR}")
		set (SDK_DIR "${INSTALL_SDK_DIR}")
		list (APPEND path_vars INCLUDE_DIR SDK_DIR)

		configure_package_config_file ("${_in}" "${_out}"
			INSTALL_DESTINATION "${INSTALL_CMAKE_DIR}"
			PATH_VARS ${path_vars}
			NO_SET_AND_CHECK_MACRO NO_CHECK_REQUIRED_COMPONENTS_MACRO
		)
	endif ()
endmacro ()

# This one is only for usable within the build tree. We want to actually
# set some variables in there from within the subdirectories, so we generated
# the intallation version later.
kadu_configure_package_config_file (cmake/KaduConfig.cmake.in
	"${CMAKE_BINARY_DIR}/KaduConfig.cmake" BUILD_TREE)

write_basic_package_version_file ("${CMAKE_BINARY_DIR}/KaduConfigVersion.cmake"
	VERSION ${simple_version} COMPATIBILITY AnyNewerVersion
)

# Include the generated file

set (Kadu_DIR "${CMAKE_BINARY_DIR}")
find_package (Kadu REQUIRED CONFIG)

if (NOT WIN32)
	include (CheckIncludeFiles)

	# TODO: Add libexecinfo support
	check_include_files ("execinfo.h" HAVE_EXECINFO)
	if (HAVE_EXECINFO)
		include (CheckFunctionExists)

		check_function_exists ("backtrace" HAVE_EXECINFO)
	endif ()
endif ()

include_directories (${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/kadu-core ${QT_INCLUDES})

add_subdirectory (kadu-core)
add_subdirectory (varia)
add_subdirectory (translations)

include (Plugins.cmake)
add_subdirectory (plugins)

if (BUILD_TESTING)
	enable_testing ()
	add_subdirectory (tests)
endif ()

add_subdirectory (kthxbye)

# Now write KaduConfig for installation.
kadu_configure_package_config_file (cmake/KaduConfig.cmake.in
	"${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/KaduConfig.cmake" INSTALL_TREE)

if (KADU_INSTALL_SDK)
	install (FILES
		"${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/KaduConfig.cmake"
		"${CMAKE_BINARY_DIR}/KaduConfigVersion.cmake"
		cmake/KaduMacros.cmake
		DESTINATION "${KADU_INSTALL_CMAKE_DIR}"
	)

	install (EXPORT KaduTargets DESTINATION "${KADU_INSTALL_CMAKE_DIR}")
endif ()

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)
add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

configure_file (varia/scripts/nsis_installer.nsi.in "${CMAKE_CURRENT_BINARY_DIR}/nsis_installer.nsi" ESCAPE_QUOTES @ONLY)

message (STATUS "Kadu (version: ${KADU_VERSION}) will be built:")
message (STATUS " * install prefix: ${CMAKE_INSTALL_PREFIX}")
if (NOT DEFINED CMAKE_CONFIGURATION_TYPES)
	message (STATUS " * build type: ${CMAKE_BUILD_TYPE}")
endif ()

install (FILES AUTHORS AUTHORS.html HISTORY README THANKS ChangeLog ChangeLog.OLD-PL DESTINATION "${KADU_INSTALL_DATA_DIR}")
# For Win32 we use GPL3, and this COPYING is GPL2
if (WIN32)
	install (FILES COPYING.WIN32 DESTINATION "${KADU_INSTALL_DATA_DIR}")
else ()
	install (FILES COPYING DESTINATION "${KADU_INSTALL_DATA_DIR}")
endif ()

=== tests/CMakeLists.txt ===
find_package (Qt4 QUIET REQUIRED COMPONENTS QtTest)

include_directories(".")

# kadu_add_test (<name> source1 source2 ... sourceN)
function (kadu_add_test name_)
	set (pluginName)

	file (RELATIVE_PATH sourcePath "${CMAKE_SOURCE_DIR}/tests" "${CMAKE_CURRENT_SOURCE_DIR}")
	if ("${sourcePath}" MATCHES "^[^/]+/plugins/.*")
		string (REGEX REPLACE "^[^/]+/plugins/" "" pluginName "${sourcePath}")
		string (REGEX REPLACE "^[^/]*/.*" "" pluginName "${pluginName}")
		# Do not add the test if it tests a plugin we do not have.
		if (NOT "${pluginName}" STREQUAL "" AND NOT TARGET ${pluginName})
			return ()
		endif ()
	endif ()

	get_filename_component (exeDir "${CMAKE_CURRENT_BINARY_DIR}/${name_}" PATH)
	file (MAKE_DIRECTORY "${exeDir}")

	add_executable (${name_} ${ARGN})
	kadu_set_flags (${name_})
	if (NOT MSVC)
		set_property (TARGET ${name_} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-error")
	endif ()
	add_test ("${sourcePath}/${name_}" ${name_})

	# Add libkadu after the plugin so that --as-needed won't drop anything
	# needed by the plugin.
	target_link_libraries (${name_} LINK_PRIVATE ${pluginName} libkadu ${QT_LIBRARIES} ${QT_QTTEST_LIBRARY})
endfunction ()

add_subdirectory (unit)

=== kadu-core/core/CMakeLists.txt ===
set (core_SRCS
	core.cpp
	crash-aware-object.cpp
)

set (core_MOC_SRCS
	core.h
)

kadu_subdirectory (core "${core_SRCS}" "${core_MOC_SRCS}" "")

=== kadu-core/formatted-string/CMakeLists.txt ===
set (formatted-string_SRCS
	composite-formatted-string.cpp
	formatted-string.cpp
	formatted-string-clone-visitor.cpp
	formatted-string-dom-visitor.cpp
	formatted-string-factory.cpp
	formatted-string-html-visitor.cpp
	formatted-string-image-block.cpp
	formatted-string-plain-text-visitor.cpp
	formatted-string-text-block.cpp
)

set (formatted-string_MOC_SRCS
	formatted-string-factory.h
)

kadu_subdirectory (formatted-string "${formatted-string_SRCS}" "${formatted-string_MOC_SRCS}" "")

=== kadu-core/misc/CMakeLists.txt ===
set (misc_SRCS
	change-notifier.cpp
	change-notifier-lock.cpp
	date-time.cpp
	date-time-parser-tags.cpp
	error.cpp
	misc.cpp
	kadu-paths.cpp
	string-utils.cpp
	syntax-list.cpp
)

set (misc_MOC_SRCS
	change-notifier.h
	syntax-list.h
)

kadu_subdirectory (misc "${misc_SRCS}" "${misc_MOC_SRCS}" "")

=== kadu-core/os/CMakeLists.txt ===
set (os_SRCS
	generic/compositing-aware-object.cpp
	generic/desktop-aware-object.cpp
	generic/desktop-aware-object-helper.cpp
	generic/system-info.cpp
	generic/url-opener.cpp
	generic/window-geometry-manager.cpp
)

set (os_MOC_SRCS
	generic/desktop-aware-object-helper.h
	generic/window-geometry-manager.h
)

if (MINGW)
	set_property (SOURCE generic/system-info.cpp APPEND_STRING PROPERTY COMPILE_FLAGS " -fno-strict-aliasing")
endif ()

kadu_subdirectory (os "${os_SRCS}" "${os_MOC_SRCS}" "")

=== kadu-core/services/CMakeLists.txt ===
set (services_SRCS
	chat-image-request-service.cpp
	chat-image-request-service-configuration.cpp
	chat-image-request-service-configurator.cpp
	image-storage-service.cpp
	message-filter-service.cpp
	message-transformer-service.cpp
	notification-service.cpp
	raw-message-transformer-service.cpp
)

set (services_MOC_SRCS
	chat-image-request-service.h
	image-storage-service.h
	message-filter-service.h
	message-transformer-service.h
	notification-service.h
	raw-message-transformer-service.h
)

kadu_subdirectory (services "${services_SRCS}" "${services_MOC_SRCS}" "")

=== plugins/antistring/CMakeLists.txt ===
project (antistring)

cmake_minimum_required (VERSION 2.8)

find_package (Kadu REQUIRED CONFIG)

set (SOURCES
	antistring.cpp
	antistring-configuration.cpp
	antistring-configuration-ui-handler.cpp
	antistring-notification.cpp
	antistring-plugin.cpp
)

set (MOC_SOURCES
	antistring.h
	antistring-configuration-ui-handler.h
	antistring-notification.h
	antistring-plugin.h
)

set (CONFIGURATION_FILES
	configuration/antistring.ui
)

set (DATA_FILES
	data/ant_conditions.conf
)

kadu_plugin (antistring
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
	PLUGIN_DATA_FILES ${DATA_FILES}
)

=== plugins/cenzor/CMakeLists.txt ===
project (cenzor)

cmake_minimum_required (VERSION 2.8)

find_package (Kadu REQUIRED CONFIG)

set (SOURCES
	configuration/gui/cenzor-configuration-ui-handler.cpp
	configuration/cenzor-configuration.cpp
	gui/widgets/list-edit-widget.cpp
	notify/cenzor-notification.cpp

	cenzor.cpp
	cenzor-plugin.cpp
)

set (MOC_SOURCES
	configuration/gui/cenzor-configuration-ui-handler.h
	gui/widgets/list-edit-widget.h
	notify/cenzor-notification.h

	cenzor.h
	cenzor-plugin.h
)

set (CONFIGURATION_FILES
	data/configuration/cenzor.ui
)

set (DATA_FILES
	data/cenzor_words.conf
	data/cenzor_words_ok.conf
)

kadu_plugin (cenzor
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
	PLUGIN_DATA_FILES ${DATA_FILES}
)

=== plugins/encryption_otr/CMakeLists.txt ===
project (encryption_otr)

cmake_minimum_required (VERSION 2.8)

find_package (Kadu REQUIRED CONFIG)

include (FindPkgConfig)

set (SOURCES
	gui/widgets/otr-account-configuration-widget-factory.cpp
	gui/widgets/otr-account-configuration-widget.cpp
	gui/widgets/otr-buddy-configuration-widget-factory.cpp
	gui/widgets/otr-buddy-configuration-widget.cpp
	gui/widgets/otr-chat-top-bar-widget-factory.cpp
	gui/widgets/otr-chat-top-bar-widget.cpp
	gui/widgets/otr-peer-identity-verification-fingerprint-exchange-page.cpp
	gui/widgets/otr-peer-identity-verification-progress-page.cpp
	gui/widgets/otr-peer-identity-verification-question-and-answer-page.cpp
	gui/widgets/otr-peer-identity-verification-respond-question-and-answer-page.cpp
	gui/widgets/otr-peer-identity-verification-respond-shared-secret-page.cpp
	gui/widgets/otr-peer-identity-verification-result-page.cpp
	gui/widgets/otr-peer-identity-verification-select-method-page.cpp
	gui/widgets/otr-peer-identity-verification-shared-secret-page.cpp

	gui/windows/otr-peer-identity-verification-window-factory.cpp
	gui/windows/otr-peer-identity-verification-window-repository.cpp
	gui/windows/otr-peer-identity-verification-window.cpp

	otr-app-ops-service.cpp
	otr-context-converter.cpp
	otr-create-private-key-job.cpp
	otr-create-private-key-worker.cpp
	otr-error-message-service.cpp
	otr-fingerprint-service.cpp
	otr-instance-tag-service.cpp
	otr-is-logged-in-service.cpp
	otr-message-event-service.cpp
	otr-message-service.cpp
	otr-notifier.cpp
	otr-op-data.cpp
	otr-op-data-factory.cpp
	otr-peer-identity-verification-service.cpp
	otr-peer-identity-verification-state.cpp
	otr-plugin.cpp
	otr-policy.cpp
	otr-policy-service.cpp
	otr-private-key-service.cpp
	otr-path-service.cpp
	otr-raw-message-transformer.cpp
	otr-session-service.cpp
	otr-timer-service.cpp
	otr-trust-level-service.cpp
	otr-user-state-service.cpp
)

set (MOC_SOURCES
	gui/widgets/otr-account-configuration-widget.h
	gui/widgets/otr-buddy-configuration-widget.h
	gui/widgets/otr-chat-top-bar-widget-factory.h
	gui/widgets/otr-chat-top-bar-widget.h
	gui/widgets/otr-peer-identity-verification-fingerprint-exchange-page.h
	gui/widgets/otr-peer-identity-verification-progress-page.h
	gui/widgets/otr-peer-identity-verification-question-and-answer-page.h
	gui/widgets/otr-peer-identity-verification-respond-question-and-answer-page.h
	gui/widgets/otr-peer-identity-verification-select-method-page.h
	gui/widgets/otr-peer-identity-verification-result-page.h
	gui/widgets/otr-peer-identity-verification-respond-shared-secret-page.h
	gui/widgets/otr-peer-identity-verification-shared-secret-page.h

	gui/windows/otr-peer-identity-verification-window-factory.h
	gui/windows/otr-peer-identity-verification-window-repository.h
	gui/windows/otr-peer-identity-verification-window.h

	otr-app-ops-service.h
	otr-context-converter.h
	otr-create-private-key-job.h
	otr-create-private-key-worker.h
	otr-error-message-service.h
	otr-fingerprint-service.h
	otr-instance-tag-service.h
	otr-is-logged-in-service.h
	otr-message-event-service.h
	otr-message-service.h
	otr-notifier.h
	otr-op-data-factory.h
	otr-path-service.h
	otr-peer-identity-verification-service.h
	otr-plugin.h
	otr-policy-service.h
	otr-private-key-service.h
	otr-raw-message-transformer.h
	otr-session-service.h
	otr-timer-service.h
	otr-trust-level-service.h
	otr-user-state-service.h
)

set (CONFIGURATION_FILES
)

pkg_check_modules (LIBOTR REQUIRED libotr>=4.0 REQUIRED)

set (LIBRARIES ${QCA2_LIBRARIES} ${LIBOTR_LDFLAGS} gcrypt)

kadu_plugin (encryption_otr
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
	PLUGIN_LIBRARIES ${LIBRARIES}
)

=== plugins/jabber_protocol/CMakeLists.txt ===
project (jabber_protocol)

cmake_minimum_required (VERSION 2.8)

# Needed for FindQCA2.cmake when building externally
list (INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/../../cmake/Modules")

find_package (Kadu REQUIRED CONFIG)

find_package (PkgConfig)
pkg_search_module (IDN REQUIRED libidn)
pkg_search_module (ZLIB zlib)

if (NOT ZLIB_FOUND)
	find_package (ZLIB REQUIRED)
endif ()

find_package (QCA2 REQUIRED)

if (APPLE)
	if (QCA_FRAMEWORK_DIR)
		set (QCA2_INCLUDE_DIR ${QCA_FRAMEWORK_DIR}/qca.framework/Headers/)
		set (QCA2_LIBRARIES "-framework qca")
		link_directories (${QCA_FRAMEWORK_DIR}/qca.framework/)
	endif ()
endif ()

kadu_api_directories (plugins/jabber_protocol
	actions
	certificates
	client
	file-transfer
	gui/widgets
	gui/windows
	gui
	open-chat-with
	resource
	server
	services
	tasks
	utils
	.
)

set (SOURCES
	actions/jabber-actions.cpp
	actions/jabber-protocol-menu-manager.cpp
	actions/show-xml-console-action-description.cpp

	certificates/certificate-display-dialog.cpp
	certificates/certificate-helpers.cpp
	certificates/trusted-certificates-manager.cpp

	client/mini-client.cpp

	file-transfer/jabber-file-transfer-handler.cpp
	file-transfer/s5b-server-manager.cpp

	gui/widgets/jabber-contact-personal-info-widget.cpp
	gui/widgets/jabber-add-account-widget.cpp
	gui/widgets/jabber-create-account-widget.cpp
	gui/widgets/jabber-edit-account-widget.cpp
	gui/widgets/jabber-personal-info-widget.cpp

	gui/windows/certificate-error-window.cpp
	gui/windows/jabber-change-password-window.cpp
	gui/windows/jabber-wait-for-account-register-window.cpp
	gui/windows/xml-console.cpp

	open-chat-with/jabber-open-chat-with-runner.cpp

	resource/jabber-resource.cpp
	resource/jabber-resource-pool.cpp

	server/jabber-avatar-downloader.cpp
	server/jabber-avatar-pep-downloader.cpp
	server/jabber-avatar-pep-uploader.cpp
	server/jabber-avatar-uploader.cpp
	server/jabber-avatar-vcard-downloader.cpp
	server/jabber-avatar-vcard-uploader.cpp
	server/jabber-server-change-password.cpp
	server/jabber-server-register-account.cpp

	services/jabber-avatar-service.cpp
	services/jabber-chat-service.cpp
	services/jabber-chat-state-service.cpp
	services/jabber-client-info-service.cpp
	services/jabber-connection-service.cpp
	services/jabber-contact-personal-info-service.cpp
	services/jabber-file-transfer-service.cpp
	services/jabber-pep-service.cpp
	services/jabber-personal-info-service.cpp
	services/jabber-roster-service.cpp
	services/jabber-server-info-service.cpp
	services/jabber-stream-debug-service.cpp
	services/jabber-subscription-service.cpp
	services/jabber-vcard-downloader.cpp
	services/jabber-vcard-service.cpp
	services/jabber-vcard-uploader.cpp

	tasks/pep-get-task.cpp
	tasks/pep-publish-task.cpp
	tasks/pep-retract-task.cpp

	iris-status-adapter.cpp
	jabber-account-details.cpp
	jabber-contact-details.cpp
	jabber-error-helper.cpp
	jabber-id-validator.cpp
	jabber-protocol.cpp
	jabber-protocol-factory.cpp
	jabber-protocol-plugin.cpp
	jabber-status-adapter.cpp
	jabber-url-dom-visitor-provider.cpp
	jabber-url-handler.cpp
	facebook-protocol-factory.cpp
	gtalk-protocol-factory.cpp
)

set (MOC_SOURCES
	actions/jabber-actions.h
	actions/show-xml-console-action-description.h

	certificates/certificate-display-dialog.h
	certificates/trusted-certificates-manager.h

	client/mini-client.h

	file-transfer/jabber-file-transfer-handler.h
	file-transfer/s5b-server-manager.h

	gui/widgets/jabber-contact-personal-info-widget.h
	gui/widgets/jabber-add-account-widget.h
	gui/widgets/jabber-create-account-widget.h
	gui/widgets/jabber-edit-account-widget.h
	gui/widgets/jabber-personal-info-widget.h

	gui/windows/certificate-error-window.h
	gui/windows/jabber-change-password-window.h
	gui/windows/jabber-wait-for-account-register-window.h
	gui/windows/xml-console.h

	resource/jabber-resource.h
	resource/jabber-resource-pool.h

	server/jabber-avatar-downloader.h
	server/jabber-avatar-pep-downloader.h
	server/jabber-avatar-pep-uploader.h
	server/jabber-avatar-uploader.h
	server/jabber-avatar-vcard-downloader.h
	server/jabber-avatar-vcard-uploader.h
	server/jabber-server-change-password.h
	server/jabber-server-register-account.h

	services/jabber-avatar-service.h
	services/jabber-chat-service.h
	services/jabber-chat-state-service.h
	services/jabber-client-info-service.h
	services/jabber-connection-service.h
	services/jabber-contact-personal-info-service.h
	services/jabber-file-transfer-service.h
	services/jabber-pep-service.h
	services/jabber-personal-info-service.h
	services/jabber-roster-service.h
	services/jabber-server-info-service.h
	services/jabber-stream-debug-service.h
	services/jabber-subscription-service.h
	services/jabber-vcard-downloader.h
	services/jabber-vcard-service.h
	services/jabber-vcard-uploader.h

	tasks/pep-get-task.h
	tasks/pep-publish-task.h
	tasks/pep-retract-task.h

	facebook-protocol-factory.h
	gtalk-protocol-factory.h
	jabber-id-validator.h
	jabber-protocol.h
	jabber-protocol-factory.h
	jabber-protocol-plugin.h
	jabber-url-handler.h
)

add_definitions (${QCA2_DEFINITIONS} ${IDN_CFLAGS_OTHER} ${ZLIB_CFLAGS_OTHER} -DIRISNET_STATIC)
add_subdirectory (3rdparty)

if (WIN32)
	include_directories (
		${QCA2_INCLUDE_DIR}

		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris-win/include
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris-win/include/iris
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris-win/src/irisnet/corelib
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris-win/src/xmpp/base64/
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris-win/src/xmpp/jid/
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris-win/src/xmpp/xmpp-core/
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris-win/src
	)
else ()
	include_directories (
		${QCA2_INCLUDE_DIR}

		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris/include
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris/include/iris
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris/src/irisnet/corelib
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris/src/xmpp/base64/
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris/src/xmpp/jid/
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris/src/xmpp/xmpp-core/
		${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libiris/src
	)
endif ()

set (LIBRARIES 3rdparty ${QCA2_LIBRARIES} ${IDN_LIBRARIES} ${ZLIB_LIBRARIES} ${QT_LIBRARIES})
if (WIN32)
	set (LIBRARIES ${LIBRARIES} advapi32 ws2_32)
endif ()

link_directories (${CMAKE_CURRENT_BUILD_DIR}/3rdparty ${IDN_LIBRARY_DIRS} ${ZLIB_LIBRARY_DIRS})

set (CONFIGURATION_FILES
	data/configuration/jabber_protocol.ui
)

kadu_plugin (jabber_protocol
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_LIBRARIES ${LIBRARIES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

add_dependencies (jabber_protocol
	3rdparty
)

=== plugins/mediaplayer/CMakeLists.txt ===
project (mediaplayer)

cmake_minimum_required (VERSION 2.8)

find_package (Kadu REQUIRED CONFIG)

kadu_api_directories (plugins/mediaplayer
	.
)

set (SOURCES
	notify/mediaplayer-notification.cpp

	mediaplayer.cpp
	mediaplayer-plugin.cpp
	mp_status_changer.cpp
)

set (MOC_SOURCES
	notify/mediaplayer-notification.h

	mediaplayer.h
	mediaplayer-plugin.h
	mp_status_changer.h
	player_commands.h
)

set (CONFIGURATION_FILES
	configuration/mediaplayer.ui
)

set (DATA_FILES
	data/mediaplayer.png
)

kadu_plugin (mediaplayer
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
	PLUGIN_DEPENDENCIES docking
	PLUGIN_LIBRARIES ${DBUS_LIBS}
	PLUGIN_DATA_FILES ${DATA_FILES}
)

=== debian/changelog ===
kadu (1.0-2) unstable; urgency=medium

  * Using dpkg-buildflags to set compilation and linker flags.
  * Added 03-no-CMAKE_CXX_FLAGS-overwrite.patch to make it possible to set
    compilation flags.
  * Removed lintian override for RPATH in Kadu's plugins.
  * Using chrpath to strip Kadu's plugins from RPATH, since they're not
    needed there.

 -- Patryk Cisek <patryk@debian.org>  Thu, 02 Oct 2014 11:55:19 +0200

kadu (1.0-1) unstable; urgency=medium

  * New upstream release (Closes: #620690, #696761)
  * Fixed build on kfreebsd-* (Closes: #755105)
  * Updated copyright information in debian/copyright
  * Added debian/tmp/usr/share/kadu/AUTHORS.html to debian/kadu.docs

 -- Patryk Cisek <patryk@debian.org>  Tue, 30 Sep 2014 19:15:28 +0200

kadu (1.0~rc10-1) unstable; urgency=medium

  * New upstream release
  * Added libkadu package

 -- Patryk Cisek <patryk@debian.org>  Thu, 25 Sep 2014 18:39:45 +0200

=== debian/control ===
Source: kadu
Section: net
Priority: optional
Maintainer: Patryk Cisek <patryk@debian.org>
Vcs-Git: git://git.debian.org/users/patryk/kadu.git
Vcs-Browser: http://git.debian.org/?p=users/patryk/kadu.git
Build-Depends: bzip2,
               chrpath,
               cmake (>=2.6),
               debhelper (>= 9),
               enchant,
               libarchive-dev,
               libasound2-dev,
               libaudio-dev,
               libdbus-1-dev,
               libenchant-dev,
               libgadu-dev,
               libidn11-dev,
               libindicate-qt-dev,
               libmpdclient-dev,
               libotr5-dev,
               libphonon-dev,
               libqca2-dev,
               libqt4-dev,
               libqtwebkit-dev,
               libsndfile1-dev (>= 1.0),
               libsqlite3-dev,
               libxfixes-dev,
               libxss-dev,
               libxtst-dev,
               patchutils (>= 0.2.25),
               pkgconf,
               sharutils,
               x11proto-scrnsaver-dev,
               zlib1g-dev
Standards-Version: 3.9.5
Homepage: http://kadu.net

Package: kadu
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: kadu-common (= ${source:Version}),
         libkadu (= ${binary:Version}),
         libqca2-plugin-ossl,
         libqt4-sql-sqlite,
         libqt4-svg,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: kadu-external-modules (<< 1.0)
Replaces: kadu-external-modules (<< 1.0)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides Kadu along with plugins developed by Kadu developers.

Package: libkadu
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package contains libkadu, which is used by Kadu.

Package: kadu-common
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: kadu-external-modules (<< 0.10.0-2)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides data common for all architectures.

Package: kadu-dev
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Development files needed to compile plugins for kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides development files needed to compile plugins for Kadu.

Package: kadu-themes
Architecture: all
Depends: ${misc:Depends}
Recommends: kadu
Description: Additional icons and emoticons for Kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides additional icons, sounds and emoticons themes for
 Kadu.
